Attribute VB_Name = "Common"
Option Explicit
Public dspa(255) As Integer
Public rdata(65535) As Long
Public cfgID(15) As String
Public cfgv(15) As Variant
Public cfgtype(15) As Byte
Public cidc As Byte

Public rdata_size As Integer
Public dspc As Byte

Private cfgfile As String

Public t1 As String * 1
Public tstr As String
Public tstr2 As String
Public tstr3 As String
Public odoa As String * 2
Public sse As String * 1
Public stab As String * 1

Public a As Long
Public b As Long
Public c As Long
Public d As Long
Public e As Long

Public Sub Init()
odoa = Chr(&HA) ' + Chr$(&HA)
sse = Chr(&H22)
stab = Chr(9)
End Sub


'Make a decimal value out of a string of bits
Public Function bitval(bitv As String, bits As Byte)
Dim pv, bv, xbit
pv = 1: For a = 1 To (bits - 1): pv = pv * 2: Next a
For xbit = 1 To bits
If Mid(bitv, xbit, 1) = "1" Then bv = bv + pv
pv = pv / 2
Next xbit
bitval = bv
End Function

'Make a decimal value out a hexidecimal value
Function dec(hexval As String)
Dim decnum As Long
Dim crate As Long
Dim posit, num
'If Len(hexval$) > 1 Then MsgBox hexval$ ': GoTo decend
If Len(hexval) = 0 Then dec = 0: Exit Function
crate = 1
posit = 0
nextnum:
num = decval(Mid(hexval, (Len(hexval) - posit), 1))
decnum = decnum + (crate * num)
crate = crate * 16
posit = posit + 1
If Not posit = Len(hexval$) Then GoTo nextnum
dec = decnum
decend:
End Function

'Make a decimal value out a hexidecimal digit
Function decval(hexval As String)
Select Case hexval$
Case "0": decval = 0
Case "1": decval = 1
Case "2": decval = 2
Case "3": decval = 3
Case "4": decval = 4
Case "5": decval = 5
Case "6": decval = 6
Case "7": decval = 7
Case "8": decval = 8
Case "9": decval = 9
Case "A": decval = 10
Case "B": decval = 11
Case "C": decval = 12
Case "D": decval = 13
Case "E": decval = 14
Case "F": decval = 15
Case "a": decval = 10
Case "b": decval = 11
Case "c": decval = 12
Case "d": decval = 13
Case "e": decval = 14
Case "f": decval = 15
End Select
End Function

'Make a nibble out of a string-letter
Public Function nibble(num As String, part As Byte) As Byte
Dim bytex, bit0, bit1, bit2, bit3, bit4, bit5, bit6, bit7, valB, b As String, bitv As String, bv4
bv4 = 0
num$ = Mid(num$, 1, 1)
bytex = Asc(num$)
If bytex > 127 Then bit0 = 1: valB = 128
If bytex > (valB + 63) Then bit1 = 1: valB = valB + 64
If bytex > (valB + 31) Then bit2 = 1: valB = valB + 32
If bytex > (valB + 15) Then bit3 = 1: valB = valB + 16
If bytex > (valB + 7) Then bit4 = 1: valB = valB + 8
If bytex > (valB + 3) Then bit5 = 1: valB = valB + 4
If bytex > (valB + 1) Then bit6 = 1: valB = valB + 2
If bytex > valB Then bit7 = 1
b$ = str$(bit0) + str$(bit1) + str$(bit2) + str$(bit3) + str$(bit4) + str$(bit5) + str$(bit6) + str$(bit7)
bitv$ = Mid(b$, 2, 1) + Mid(b$, 4, 1) + Mid(b$, 6, 1) + Mid(b$, 8, 1) + Mid(b$, 10, 1) + Mid(b$, 12, 1) + Mid(b$, 14, 1) + Mid(b$, 16, 1)

Select Case part
Case 0
If Mid(bitv$, 1, 1) = "1" Then bv4 = bv4 + 8
If Mid(bitv$, 2, 1) = "1" Then bv4 = bv4 + 4
If Mid(bitv$, 3, 1) = "1" Then bv4 = bv4 + 2
If Mid(bitv$, 4, 1) = "1" Then bv4 = bv4 + 1
Case 1
If Mid(bitv$, 5, 1) = "1" Then bv4 = bv4 + 8
If Mid(bitv$, 6, 1) = "1" Then bv4 = bv4 + 4
If Mid(bitv$, 7, 1) = "1" Then bv4 = bv4 + 2
If Mid(bitv$, 8, 1) = "1" Then bv4 = bv4 + 1
End Select

nibble = bv4

nibblend:
End Function

'Make a string of bits out of a byte
Public Function makebits(bytex) As String
Dim bs As String, bitX(7), valB
If bytex > 127 Then bitX(0) = 1: valB = 128
If bytex > (valB + 63) Then bitX(1) = 1: valB = valB + 64
If bytex > (valB + 31) Then bitX(2) = 1: valB = valB + 32
If bytex > (valB + 15) Then bitX(3) = 1: valB = valB + 16
If bytex > (valB + 7) Then bitX(4) = 1: valB = valB + 8
If bytex > (valB + 3) Then bitX(5) = 1: valB = valB + 4
If bytex > (valB + 1) Then bitX(6) = 1: valB = valB + 2
If bytex > valB Then bitX(7) = 1
bs = str(bitX(0)) + str(bitX(1)) + str(bitX(2)) + str(bitX(3)) + str(bitX(4)) + str(bitX(5)) + str(bitX(6)) + str(bitX(7))
makebits = Mid(bs, 2, 1) + Mid(bs, 4, 1) + Mid(bs, 6, 1) + Mid(bs, 8, 1) + Mid(bs, 10, 1) + Mid(bs, 12, 1) + Mid(bs, 14, 1) + Mid(bs, 16, 1)
End Function

'Get a bit from a byte
Public Function bytebit(bytex, bp) As Byte
Dim bitX(7)
Dim valB
If bytex > 127 Then bitX(0) = 1: valB = 128
If bytex > (valB + 63) Then bitX(1) = 1: valB = valB + 64
If bytex > (valB + 31) Then bitX(2) = 1: valB = valB + 32
If bytex > (valB + 15) Then bitX(3) = 1: valB = valB + 16
If bytex > (valB + 7) Then bitX(4) = 1: valB = valB + 8
If bytex > (valB + 3) Then bitX(5) = 1: valB = valB + 4
If bytex > (valB + 1) Then bitX(6) = 1: valB = valB + 2
If bytex > valB Then bitX(7) = 1
bytebit = bitX(bp)
'bs$ = str$(bitX(0)) + str$(bitX(1)) + str$(bitX(2)) + str$(bitX(3)) + str$(bitX(4)) + str$(bitX(5)) + str$(bitX(6)) + str$(bitX(7))
'makebits$ = Mid(bs$, 2, 1) + Mid(bs$, 4, 1) + Mid(bs$, 6, 1) + Mid(bs$, 8, 1) + Mid(bs$, 10, 1) + Mid(bs$, 12, 1) + Mid(bs$, 14, 1) + Mid(bs$, 16, 1)
End Function

Public Function BoolBit(bool As Boolean) As String
If bool Then BoolBit = "1" Else BoolBit = "0"
End Function

Public Function VWidth(var, min, max)
If var < min Then var = min
If var > max Then var = max
VWidth = var
End Function

'Simple GBC-tile painter
Sub GBCtiledraw(object As PictureBox, Y As Integer, X As Integer, ScaleX As Byte, ScaleY As Byte, FlipY, FlipX, layerflag, Source As Long, palette() As Variant)
Dim r, g, b, pixY, pixX, byteA, byteB, valbA, valbB, high, bitX
For pixY = 0 To 7
'byteA = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 1, 1))
'byteB = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 2, 1))
valbA = 0: valbB = 0: high = 128
For pixX = 0 To 7
'bitX = 0: If byteA > (valbA + (high - 1)) Then bitX = 1: valbA = valbA + high
'If byteB > (valbB + (high - 1)) Then bitX = bitX Or 2: valbB = valbB + high
bitX = ((byteA And (2 ^ (7 - Abs((FlipX * 7) - pixX)))) > 0 And 1) + _
      ((byteB And (2 ^ (7 - Abs((FlipX * 7) - pixX)))) > 0 And 1 * 2)
If bitX Or layerflag Then
'r = (palette(bitX) And &HFF)
'g = ((Int(palette(bitX) / &H100) And &HFF) * &H100)
'b = ((Int(palette(bitX) / &H10000) And &HFF) * &H10000)
object.Line ((X + pixX) * ScaleX, (Y + pixY) * ScaleY)-(((X + pixX) * ScaleX) + (ScaleX - 1), ((Y + pixY) * ScaleY) + (ScaleY - 1)), palette(bitX), BF
'object.Line ((x + pixX) * ScaleX, (Y + pixY) * ScaleY)-(((x + pixX) * ScaleX), ((Y + pixY) * ScaleY)), r, BF
'object.Line ((x + pixX) * ScaleX + 1, (Y + pixY) * ScaleY)-(((x + pixX) * ScaleX) + 1, ((Y + pixY) * ScaleY)), b, BF
'object.Line ((x + pixX) * ScaleX, (Y + pixY) * ScaleY + 1)-(((x + pixX) * ScaleX), ((Y + pixY) * ScaleY) + 1), g, BF
'object.Line ((x + pixX) * ScaleX + 1, (Y + pixY) * ScaleY + 1)-(((x + pixX) * ScaleX) + 1, ((Y + pixY) * ScaleY) + 1), 0, BF
End If
high = high / 2
Next pixX
Next pixY
End Sub

'Simple NES tile painter
Sub NEStiledraw(object As PictureBox, Y As Integer, X As Integer, ScaleX As Byte, ScaleY As Byte, FlipY, FlipX, layerflag, Source() As Variant, palette() As Variant)
Dim r, g, b, pixY, pixX, byteA, byteB, valbA, valbB, high, bitX
For pixY = 0 To 7
byteA = Source(Abs((FlipY * 7) - pixY) + 0) 'Asc(Mid(romdat, Source + Abs((FlipY * 7) - pixY) + 1, 1))
byteB = Source(Abs((FlipY * 7) - pixY) + 8) 'Asc(Mid(romdat, Source + Abs((FlipY * 7) - pixY) + 9, 1))
valbA = 0: valbB = 0: high = 128
For pixX = 0 To 7
bitX = ((byteA And (2 ^ (7 - Abs((FlipX * 7) - pixX)))) > 0 And 1) + _
      ((byteB And (2 ^ (7 - Abs((FlipX * 7) - pixX)))) > 0 And 1 * 2)
If bitX Or layerflag Then
object.Line ((X + pixX) * ScaleX, (Y + pixY) * ScaleY)-(((X + pixX) * ScaleX) + (ScaleX - 1), ((Y + pixY) * ScaleY) + (ScaleY - 1)), palette(bitX), BF
End If
high = high / 2
Next pixX
Next pixY
End Sub

Public Function SrcString(StrPos) As String
Dim a, b
'Dim tstr As String
tstr = ""
a = 0
Do
    b = rdata(StrPos + a)
    a = a + 1
    If b >= 255 Then GoTo SrcString_le
    tstr = tstr + Chr$(b)
Loop
SrcString_le:
SrcString = tstr
End Function

Public Function GetCfg(id As String) As Variant
Dim a
Do
If cfgID(a) = id Then GetCfg = cfgv(a): Exit Function
a = a + 1
Loop Until a = cidc
MsgBox "Cant find config ID: " + id$
End Function

Public Sub LoadCfg(file As String)
Dim tint As Integer, tstr$
cfgfile = file
ChDir App.Path
Open cfgfile$ For Binary As #1
cfgl:
Do
Get #1, , t1
If t1$ = "=" Then GoTo cfgeq
If t1$ = "/" Then GoTo cfge
cfgID(cidc) = cfgID(cidc) + t1$
Loop Until EOF(1)
cfgeq:
Get #1, , t1
Select Case t1
Case "#"
    cfgtype(cidc) = 0
    tstr = ""
    Do
    Get #1, , t1$: If t1$ = ";" Then cfgv(cidc) = val(tstr$): cidc = cidc + 1: Get #1, , tint: GoTo cfgl
    tstr = tstr + t1
    Loop Until EOF(1)
Case sse
    cfgtype(cidc) = 1
    tstr = ""
    Do
    Get #1, , t1: If t1 = sse Then cfgv(cidc) = tstr: cidc = cidc + 1: Get #1, , tint: GoTo cfgl
    tstr = tstr + t1
    Loop Until EOF(1)
End Select
cfge:
Close #1
End Sub


Public Sub SetCfg(id, val As Variant)
a = 0
Do
If cfgID(a) = id Then cfgv(a) = val: GoTo savecfg
a = a + 1
Loop Until a = cidc
MsgBox "Cant set config ID: " + id
savecfg:
ChDir App.Path
Open cfgfile For Output As #1
For a = 0 To (cidc - 1)
Select Case cfgtype(a)
Case 0: Print #1, cfgID(a) + "=#" + CStr(cfgv(a)) + ";"
Case 1: Print #1, cfgID(a) + "=" + sse + cfgv(a) + sse
End Select
Next a
Print #1, "/"
Close #1
End Sub

Public Sub SetTBCool(tb As TextBox, text As String)
tb.Tag = ":)"   'disable tb_Change routine's action by using .Tag
Dim spos
spos = tb.SelStart
If tb.text = "" Then spos = 1
tb.text = text      'set
tb.SelStart = spos     'restore current cursor position
tb.Tag = ""     're-enable tb_Change
End Sub

Public Sub SetOptCool(opt As OptionButton, oval As Boolean)
opt.Tag = ":)"
opt.Value = oval
opt.Tag = ""
End Sub

Public Function RGBmirr(col)
RGBmirr = RGB(Int(col / 65536) And 255, Int(col / 256) And 255, col And 255)
'RGBmirr = ((col And &HFF) * 65536) + (((col / &H100) And &HFF) * 256) + ((col / &H10000) And &HFF)
End Function


Public Sub LoadResDat(file$, dbug, outform As Form)
Dim tdspa(255) As Long
Dim tdspt(255) As String
Dim Index(255) As Integer
Dim index_count, inbrace, tstr As String, mf
Dim a, b, c


Open file$ For Binary As #1
Do
Get #1, , t1$
Select Case t1$
Case "/": Do: Get #1, , t1$: Loop Until t1$ = "/" Or EOF(1)
Case "{"
    index_count = 0
    inbrace = 1
    tdspa(dspc) = a
    Do
    Get #1, , t1$
    If Not t1$ = "_" Then
        If Asc(t1$) < Asc("a") Or Asc(t1$) > Asc("z") Then
            If Asc(t1$) < Asc("0") Or Asc(t1$) > Asc("9") Then GoTo dspl_nb
        End If
    End If
    tdspt$(dspc) = tdspt$(dspc) + t1$
    Loop Until EOF(1)
Case "}"
    inbrace = 0
    If dbug Then outform.Print "$"; Hex$(tdspa(dspc)); ": "; tdspt$(dspc)
    dspc = dspc + 1
    If index_count Then
        tdspa(dspc) = a
        tdspt$(dspc) = tdspt$(dspc - 1) + "&index"
        For b = 1 To index_count
            rdata(a) = Index(b - 1): a = a + 1
        Next b
        If dbug Then outform.Print "$"; Hex$(tdspa(dspc)); ": "; tdspt$(dspc)
        dspc = dspc + 1
    End If
Case "!":
morenum:
    tstr$ = ""
    Get #1, , t1$: If t1$ = "-" Then mf = 1: Get #1, , t1$ Else mf = 0
    Do
    If t1$ = "#" Then t1$ = "1"
    If t1$ = "." Then t1$ = "0"
    If Asc(t1$) < Asc("0") Or Asc(t1$) > Asc("9") Then
        If Asc(t1$) < Asc("A") Or Asc(t1$) > Asc("F") Then GoTo dspl_bytedone
    End If
    tstr$ = tstr$ + t1$
    Get #1, , t1$
    Loop Until EOF(1)
dspl_bytedone:
    c = 1: For b = 0 To Len(tstr$) - 1: rdata(a) = rdata(a) + (dec(Mid(tstr$, (Len(tstr$) - b), 1)) * c): c = c * 16: Next b
    If mf Then rdata(a) = rdata(a) - rdata(a) - rdata(a)
    a = a + 1
    If t1$ = "!" Then GoTo morenum
Case Chr$(34)
    Do: Get #1, , t1$
    If Asc(t1$) = 34 Then rdata(a) = 255: a = a + 1: GoTo dspl_nb
    rdata(a) = Asc(t1$): a = a + 1
    Loop Until EOF(1)
Case "&"
    Index(index_count) = a: index_count = index_count + 1
Case "%"
    tstr$ = ""
    Do: Get #1, , t1$
    If t1$ = "=" Then GoTo dspl_mapnd
    tstr$ = tstr$ + t1$: Loop Until EOF(1)
dspl_mapnd:
    b = val(tstr$): tstr$ = ""
    Do: Get #1, , t1$
    If Not t1$ = "_" And Not t1$ = "&" Then
        If Asc(t1$) < Asc("a") Or Asc(t1$) > Asc("z") Then
            If Asc(t1$) < Asc("0") Or Asc(t1$) > Asc("9") Then GoTo dspl_maptd
        End If
    End If
    tstr$ = tstr$ + t1$: Loop Until EOF(1)
dspl_maptd:
    For c = 0 To dspc - 1: If tdspt$(c) = tstr$ Then GoTo dspl_mapftd
    Next c
dspl_mapftd:
    dspa(b) = tdspa(c)
Case Else
End Select
dspl_nb:
Loop Until EOF(1)
rdata_size = a
Close #1
End Sub

Public Function GetFileString(chn As Byte) As String
Dim ctstr$
Dim ct1$
ct1$ = " "
Do
Get chn, , ct1$
If Asc(ct1$) = &HD Then GetFileString = ctstr$: Exit Function
If Asc(ct1$) = &HA Then GetFileString = ctstr$: Exit Function
If Asc(ct1$) = &H9 Then GetFileString = ctstr$: Exit Function
If Asc(ct1$) = &H20 Then GetFileString = ctstr$: Exit Function
ctstr$ = ctstr$ + ct1$
Loop Until EOF(chn)
End Function

Public Sub DumpString(str As String)
ChDir App.Path
If Dir("dump.log") <> "" Then Kill "dump.log"
Open "dump.log" For Binary As #1
'Dim a As String
'a = ResData(CurResFile)
Put #1, , str
Close #1
End Sub

Public Sub Killifexistandopen(FileName As String, port As Byte)
If Dir(FileName) <> "" Then Kill FileName
Open FileName For Binary As port
End Sub

