VERSION 5.00
Begin VB.Form Config 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Configuration"
   ClientHeight    =   2145
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5715
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2145
   ScaleWidth      =   5715
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox CACheck 
      Caption         =   "Enable Simulation of CHR Animations"
      Height          =   255
      Left            =   240
      TabIndex        =   12
      Top             =   1800
      Width           =   3135
   End
   Begin VB.TextBox SRCTB 
      Height          =   285
      Left            =   960
      TabIndex        =   11
      Top             =   2880
      Visible         =   0   'False
      Width           =   2175
   End
   Begin VB.TextBox PADTB 
      Height          =   285
      Left            =   960
      TabIndex        =   10
      Top             =   2400
      Visible         =   0   'False
      Width           =   2175
   End
   Begin VB.OptionButton DatLoadOpt 
      Caption         =   "Load Pre-Assembled source data at startup (fast)"
      Height          =   255
      Index           =   0
      Left            =   600
      TabIndex        =   9
      Top             =   2160
      Visible         =   0   'False
      Width           =   3855
   End
   Begin VB.OptionButton DatLoadOpt 
      Caption         =   "Assemble source data at startup (debugging)"
      Height          =   255
      Index           =   1
      Left            =   600
      TabIndex        =   8
      Top             =   2640
      Visible         =   0   'False
      Width           =   3495
   End
   Begin VB.CommandButton PALReloadBtn 
      Caption         =   "Reload Now"
      Height          =   255
      Left            =   4440
      TabIndex        =   7
      Top             =   1200
      Width           =   1095
   End
   Begin VB.CheckBox PACheck 
      Caption         =   "Enable Simulation of Palette-Animations"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   1560
      Width           =   3135
   End
   Begin VB.CommandButton PALBrowseBtn 
      Caption         =   "Browse.."
      Height          =   255
      Left            =   4440
      TabIndex        =   5
      Top             =   960
      Width           =   1095
   End
   Begin VB.CommandButton EmuBrowseBtn 
      Caption         =   "Browse.."
      Height          =   255
      Left            =   4440
      TabIndex        =   4
      Top             =   600
      Width           =   1095
   End
   Begin VB.TextBox PALTB 
      Height          =   285
      Left            =   1560
      TabIndex        =   3
      Top             =   1080
      Width           =   2775
   End
   Begin VB.TextBox EmuTB 
      Height          =   285
      Left            =   240
      TabIndex        =   1
      Top             =   600
      Width           =   4095
   End
   Begin VB.Label Label2 
      Caption         =   "NES Palette File:"
      Height          =   255
      Left            =   240
      TabIndex        =   2
      Top             =   1080
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Emulator full filename for Test feature (must support rom name at command line):"
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "Config"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Sub Update()
SetTBCool EmuTB, GetCfg("emufname")
SetTBCool PALTB, GetCfg("palfile")
PACheck.Value = GetCfg("palanim")
CACheck.Value = GetCfg("chranim")
'SetOptCool DatLoadOpt(GetCfg("datloadtype")), True
'SetTBCool PADTB, GetCfg("padfile")
'SetTBCool SRCTB, GetCfg("datfile")
End Sub

Private Sub EmuBrowseBtn_Click()
Dim cdl As New clsDialog
tstr = cdl.ShowOpen(Me.hWnd, "Pick the Emu..", , "Programs (*.exe)|*.exe|all files (*.*)|*.*", FILEMUSTEXIST Or LONGNAMES)
If Len(tstr) = 0 Then Exit Sub
SetCfg ("emufname"), Left(tstr, Len(tstr) - 1)
Config.Update
End Sub

Private Sub EmuTB_Change()
If EmuTB.Tag <> "" Then Exit Sub
SetCfg ("emufname"), EmuTB.text
Config.Update
End Sub


Private Sub PACheck_Click()
SetCfg ("palanim"), PACheck.Value
MFLE_Main.PalAnimT.Enabled = GetCfg("palanim")
Config.Update
End Sub

Private Sub PALBrowseBtn_Click()
Dim cdl As New clsDialog
tstr = cdl.ShowOpen(Me.hWnd, "Pick the Palette..", , "NES Palettes (*.pal)|*.pal|all files (*.*)|*.*", FILEMUSTEXIST Or LONGNAMES)
If Len(tstr) = 0 Then Exit Sub
SetCfg ("palfile"), tstr
Config.Update
End Sub

Private Sub PALReloadBtn_Click()
MFLE_Main.ReloadNESPAL
MFLE_Main.GetMMCols
MFLE_Main.Update_Level
End Sub

Private Sub PALTB_Change()
If PALTB.Tag <> "" Then Exit Sub
SetCfg ("palfile"), EmuTB.text
Config.Update
End Sub


