VERSION 5.00
Begin VB.Form MFLE_Main 
   AutoRedraw      =   -1  'True
   Caption         =   "MegaFLE X - version 0.31"
   ClientHeight    =   5175
   ClientLeft      =   165
   ClientTop       =   555
   ClientWidth     =   5280
   BeginProperty Font 
      Name            =   "Lucida Console"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "MFLE_Main.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   5175
   ScaleWidth      =   5280
   Begin VB.Timer CHRAnimT 
      Interval        =   15
      Left            =   4560
      Top             =   360
   End
   Begin VB.CommandButton Command1 
      Caption         =   "DumpRes"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   3480
      TabIndex        =   0
      Top             =   4800
      Width           =   1575
   End
   Begin VB.Timer PalAnimT 
      Interval        =   15
      Left            =   4560
      Top             =   0
   End
   Begin VB.Menu Menu_File 
      Caption         =   "File"
      Begin VB.Menu File_Save 
         Caption         =   "Save"
         Shortcut        =   {F5}
      End
      Begin VB.Menu File_Back 
         Caption         =   "Load Backup"
         Shortcut        =   {F8}
      End
      Begin VB.Menu File_Exit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu Menu_View 
      Caption         =   "Level"
      Begin VB.Menu View_PalEd 
         Caption         =   "Palette Editor"
      End
      Begin VB.Menu View_TT 
         Caption         =   "Tile Table"
      End
      Begin VB.Menu View_TSAT 
         Caption         =   "TSA Table"
      End
      Begin VB.Menu View_StrT 
         Caption         =   "Structure Table"
      End
      Begin VB.Menu View_ScreenEd 
         Caption         =   "Screen Editor"
      End
      Begin VB.Menu View_EnemEd 
         Caption         =   "Enemy Editor"
      End
      Begin VB.Menu Level_Misc 
         Caption         =   "Miscanneleous"
         Visible         =   0   'False
      End
      Begin VB.Menu Level_bl0 
         Caption         =   "-"
      End
      Begin VB.Menu Level_Next 
         Caption         =   "Next"
         Shortcut        =   {F7}
      End
      Begin VB.Menu Level_Previous 
         Caption         =   "Previous"
         Shortcut        =   {F6}
      End
   End
   Begin VB.Menu Menu_Tools 
      Caption         =   "Tools"
      Begin VB.Menu Tools_Test 
         Caption         =   "Test!"
         Shortcut        =   {F9}
      End
   End
   Begin VB.Menu Menu_Config 
      Caption         =   "Config"
   End
End
Attribute VB_Name = "MFLE_Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private updlevel
Private Gman_FC As Byte
Private Gman_OF As Byte

Public Sub Global_KeyDown(KeyCode As Integer, Shift As Integer)
If KeyCode = vbKeyF7 Then MFLE_Main.Level_Next_Click
If KeyCode = vbKeyF6 Then MFLE_Main.Level_Previous_Click
If KeyCode = vbKeyF5 Then MFLE_Main.File_Save_Click
If KeyCode = vbKeyF8 Then MFLE_Main.File_Back_Click
If KeyCode = vbKeyF9 Then MFLE_Main.Tools_Test_Click
If Shift = 1 Then
    If KeyCode = vbKeyP Then MFLE_Main.View_PalEd_Click
    If KeyCode = vbKeyT Then MFLE_Main.View_TT_Click
    If KeyCode = vbKeyB Then MFLE_Main.View_TSAT_Click
    If KeyCode = vbKeyR Then MFLE_Main.View_StrT_Click
    If KeyCode = vbKeyS Then MFLE_Main.View_ScreenEd_Click
    If KeyCode = vbKeyE Then MFLE_Main.View_EnemEd_Click
End If
End Sub

Private Sub Form_Load()
Common.Init
PalAnimT.Enabled = False
CHRAnimT.Enabled = False

ChDir App.Path
LoadCfg "megaflex.cfg"

ReloadNESPAL

FileName = "megaman5.nes"
gem = 2
GoTo debuginit

tstr = LCase(InputBox("Input Editing Mode ('mm3', 'mm4' or 'mm5')."))
If tstr = "mm3" Then gem = 0
If tstr = "mm4" Then gem = 1
If tstr = "mm5" Then gem = 2

Dim cdl As New clsDialog
FileName = cdl.ShowOpen(Me.hWnd, "Select Megaman " + CStr(3 + gem) + " ROM", , "nes roms (*.nes)|*.nes|all files (*.*)|*.*", FILEMUSTEXIST Or HIDEREADONLY Or LONGNAMES)
'FileName = Left(FileName, Len(FileName) - 1)
FileName = Left(FileName, Len(FileName) - 1)
If Len(FileName) = 0 Then File_Exit_Click: End

debuginit:
Print "Opened " + sse + FileName + sse
Print "Editing mode: Megaman " + CStr(3 + gem)
Print "--"

ChDir App.Path
LoadResDat GetCfg("datfile"), 1, MFLE_Main

Open FileName For Binary As #1
romdat = Space(LOF(1))
Get #1, , romdat
Close #1

glob_pal(&H21) = RGB(&HA0, &HA0, &HA0)
glob_pal(&H22) = RGB(&HFF, &HFF, &HFF)
glob_pal(&H23) = RGB(&HFF, &H60, &H60)
glob_pal(&H24) = RGB(&H60, &H60, &HFF)
glob_pal(&H25) = RGB(&H60, &HFF, &H60)
glob_pal(&H26) = RGB(&H0, &HFF, &HFF)
glob_pal(&H27) = RGB(&HFF, &H60, &HFF)

For b = 0 To 2
For a = 0 To offsnum
If rdata(dspa(d_offst) + a) = 0 Then offs(b, a) = rdata(dspa(b) + a)
Next a
Next b

GetMMCols

level = 0
'gem = 1

Update_Level

'ReDim SBD_Base(15, &H3F, &HFF)    'Dim 1: Level
't = Asc(mid(romdat, 1 + leveloff + rdata(dspa(gem) + 25), 1))
PalAnimT.Enabled = GetCfg("palanim")
CHRAnimT.Enabled = True
End Sub

Public Sub ReloadNESPAL()
Dim r, g, b, hr, hg, hb
palfile = GetCfg("palfile")
Open palfile For Binary As #1
For a = 0 To &HFF
Get #1, , t1: r = Asc(t1$)
Get #1, , t1: g = Asc(t1$)
Get #1, , t1: b = Asc(t1$)
NESPAL(a) = RGB(b, g, r)
NESPALD(a) = RGB(b / 1.5, g / 1.5, r / 1.5)
hr = VWidth(r + 80, 0, 255)
hg = VWidth(g + 80, 0, 255)
hb = VWidth(b + 80, 0, 255)
NESPALL(a) = RGB(hb, hg, hr)
Next a
Close #1
End Sub

Public Sub GetMMCols()
Dim col
For col = 0 To &HF
If (col And 3) = 0 Then
    glob_pal(col + &H40) = RGB(&H80, 0, &H80)
Else
    If col < 8 Then glob_pal(col + &H40) = NESPAL(Asc(Mid(romdat, offs(gem, o_mmpal) + col, 1)))
End If
Next col
Update_Global_Pal
End Sub

Public Sub Update_Level()
leveloff = rdata(dspa(gem) + 1)
For a = 1 To level
leveloff = leveloff + &H2000
Next a

For b = 0 To 2
For a = 0 To offsnum
If rdata(dspa(d_offst) + a) = 1 Then offs(b, a) = leveloff + rdata(dspa(b) + a)
Next a
Next b

If gem = 0 Or gem = 2 Then
    sbdoff = rdata(dspa(gem) + 1)
    For a = 1 To Asc(Mid(romdat, offs(gem, o_sbd) + level, 1))
    sbdoff = sbdoff + &H2000
    Next a
Else
    sbdoff = leveloff
End If

For b = 0 To 2
For a = 0 To offsnum
If rdata(dspa(d_offst) + a) = 2 Then offs(b, a) = sbdoff + rdata(dspa(b) + a)
Next a
Next b

For a = 0 To 3: PA_ID(a) = 0: Next a
CA_ID = 0

Dim chroffs As Long
Dim chrbankoffs1 As Long, chrbankoffs2 As Long

If gem = 0 Or gem = 2 Then
chrbankoffs1 = Asc(Mid(romdat, leveloff + rdata(dspa(gem) + o_chrpt), 1))
chrbankoffs1 = chrbankoffs1 * &H400
chrbankoffs2 = Asc(Mid(romdat, leveloff + rdata(dspa(gem) + o_chrpt) + 1, 1))
chrbankoffs2 = chrbankoffs2 * &H400

Dim t
For t = 0 To 127
If gem = 0 Then chrmap(t + 256) = offs(gem, o_chroffs) + (t * 16)
chrmap(t) = offs(gem, o_chroffs) + chrbankoffs1 + (t * &H10)
chrmap(t + 128) = offs(gem, o_chroffs) + chrbankoffs2 + (t * &H10)
Next t
End If

If gem = 2 Then
    For t = 0 To 63
    chrmap(t + &H100) = offs(gem, o_chroffs) + (t * 16)
    chrmap(t + &H140) = offs(gem, o_chroffs) + &H1800& + (t * 16)
    Next t
End If

If gem = 1 Then InitEffectLoad

If PalEd.Visible Then PalEd.Update_Level
If TileTable.Visible Then TileTable.Update_Level
If TSATable.Visible Then TSATable.Update_Level
If StrTable.Visible Then StrTable.Update_Level
If ScreenEd.Visible Then ScreenEd.Update_Level
If EnemEd.Visible Then EnemEd.Update_Level

If GetCfg("cllevelscr") > 0 Then curscreen = 0

updlevel = True
Update_Scrn
updlevel = False
End Sub

Public Sub InitEffectLoad()
Dim lidLo, lidHi, lidoff
lidLo = Asc(Mid(romdat, rdata(dspa(d_ex) + 2) + level, 1))
lidHi = Asc(Mid(romdat, rdata(dspa(d_ex) + 3) + level, 1))
lidHi = (lidHi - &HA0) + rdata(dspa(d_ex) + 4)
lidoff = (lidHi * 256) + lidLo + &H11

EffectLoad lidoff, &H10
End Sub

Public Sub EffectLoad(eoff, sizedim)
Dim pt
For c = 0 To 7
pt = pt + 1
If Asc(Mid(romdat, eoff + c, 1)) >= &H80 Then GoTo effload_paldone
If (c And 3) > 0 Then
    sprpaloff(c) = eoff + c
    glob_pal(c + &H48) = NESPAL(Asc(Mid(romdat, eoff + c, 1)))
End If
Next c
effload_paldone:
Update_Global_Pal

'0 = Source Bank
'1 = Tiles/Rows to copy ($10/$100 bytes)
'2 = Source High byte offset
'3 = Dest. High byte Offset

effloadloop:
If Asc(Mid(romdat, eoff + 0 + pt, 1)) >= &H80 Then GoTo doneeffload
c = Asc(Mid(romdat, eoff + 0 + pt, 1))
d = Asc(Mid(romdat, eoff + 2 + pt, 1))
If Asc(Mid(romdat, eoff + 3 + pt, 1)) < &H20 Then
    For b = 0 To (Asc(Mid(romdat, eoff + 1 + pt, 1)) * sizedim) - 1
    If (Asc(Mid(romdat, eoff + 3 + pt, 1)) * &H10) + b >= &H200 Then GoTo effloadnext
    chrmap((Asc(Mid(romdat, eoff + 3 + pt, 1)) * &H10) + b) = (c * &H2000) + ((d - &H80) * &H100) + (b * &H10) + &H10
    Next b
End If
effloadnext:
pt = pt + 4
If pt < &H100 Then GoTo effloadloop
doneeffload:
End Sub

Public Sub Update_BGPal(upd, animcl)
Dim col
Dim edscrpos, enem
Dim ID_taken_tmp(3) As Boolean
Dim palupdflag As Boolean

palupdflag = False
Select Case gem
Case 0
palset = Asc(Mid(romdat, offs(gem, o_ddA) + (curscroll * 2) + 1, 1))
palupdflag = True
Case 1
a = Asc(Mid(romdat, offs(gem, o_ddA) + curscroll, 1))
If a > 0 Or curscroll = 0 Or updlevel = True Then
    palupdflag = True
    palset = a
End If
Case 2
If curscroll = 0 Or updlevel = True Then palupdflag = True: palset = 0
a = Asc(Mid(romdat, offs(gem, o_ddA) + curscroll, 1)) And &H3F
If a > 0 Then
    b = Asc(Mid(romdat, offs(gem, 27) + ((a - 1) * 8), 1))
    If b >= &H80 Then
        palupdflag = True
        palset = (b And &H7F)
    End If
    b = Asc(Mid(romdat, offs(gem, 27) + ((a - 1) * 8) + 4, 1))
    If b > 0 Then
        b = b * &H400
        For c = 0 To 127
        chrmap(c + 128) = offs(gem, o_chroffs) + b + (c * &H10)
        Next c
    End If
End If
'palupdflag = True
'For b = 0 To 3: PA_ID(b) = Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + &H10 + b, 1)): Next b
End Select

If palupdflag = True Then
    For col = 0 To &HF
    If (col And 3) = 0 Then
        glob_pal(col) = NESPAL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + 0, 1)))
        glob_pal(col + &H10) = NESPALD(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + 0, 1)))
        glob_pal(col + &H30) = NESPALL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + 0, 1)))
        glob_pal(col + &H50) = NESPAL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + 0, 1)))
    Else
        glob_pal(col) = NESPAL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + col, 1)))
        glob_pal(col + &H10) = NESPALD(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + col, 1)))
        glob_pal(col + &H30) = NESPALL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + col, 1)))
        glob_pal(col + &H50) = NESPAL(Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + col, 1)))
    End If
    Next col
    For a = 0 To 3: PA_ID(a) = Asc(Mid(romdat, offs(gem, o_pal) + (palset * &H14) + &H10 + a, 1)): Next a
End If

edscrpos = 0
Select Case gem
Case 1
For enem = 0 To offs(gem, 19)
a = Asc(Mid(romdat, offs(gem, 11) + enem, 1))
If a > edscrpos Then edscrpos = a
If a < edscrpos Then GoTo donefindeffspr4 'findeffsprnext5
If a < curscreen Then GoTo findeffsprnext4
If a >= curscroll_sscrn And a < nextscroll_sscrn Then 'p = curscreen
    If Asc(Mid(romdat, offs(gem, 14) + enem, 1)) >= &HC0 Then
        a = Asc(Mid(romdat, offs(gem, 14) + enem, 1)) And &H3F
        b = Asc(Mid(romdat, rdata(dspa(d_ex) + 8) + a, 1)) And 3
        c = Asc(Mid(romdat, rdata(dspa(d_ex) + 9) + a, 1))
        If c >= &H80 And ID_taken_tmp(b) = False Then
            ID_taken_tmp(b) = True
            PA_ID(b) = c
            PA_DelayC(b) = 0
            PA_FrameN(b) = 0
        Else
            For col = 1 To 3
                glob_pal((b * 4) + col) = NESPAL(Asc(Mid(romdat, rdata(dspa(d_ex) + 10) + (c * 4) + col, 1)))
                glob_pal((b * 4) + col + &H10) = NESPALD(Asc(Mid(romdat, rdata(dspa(d_ex) + 10) + (c * 4) + col, 1)))
                glob_pal((b * 4) + col + &H30) = NESPALL(Asc(Mid(romdat, rdata(dspa(d_ex) + 10) + (c * 4) + col, 1)))
                glob_pal((b * 4) + col + &H50) = NESPAL(Asc(Mid(romdat, rdata(dspa(d_ex) + 10) + (c * 4) + col, 1)))
            Next col
        End If
    End If
End If
findeffsprnext4:
Next enem
donefindeffspr4:
Case 2
For enem = 0 To offs(gem, 19)
a = Asc(Mid(romdat, offs(gem, 11) + enem, 1))
If a > edscrpos Then edscrpos = a
If a < edscrpos Then GoTo donefindeffspr5 'findeffsprnext5
If a < curscreen Then GoTo findeffsprnext5
If a >= curscroll_sscrn And a < nextscroll_sscrn Then 'p = curscreen
    d = Asc(Mid(romdat, offs(gem, 14) + enem, 1))
    If d >= &HC0 Then
        c = (d And &H3F)
        a = Asc(Mid(romdat, rdata(dspa(d_ex) + 12) + c, 1))
        If a >= &H80 Then
            CA_ID = a
        Else
            If a >= &H10 Then
putchrbank5:
                b = Asc(Mid(romdat, rdata(dspa(d_ex) + 16) + a, 1))
                c = Asc(Mid(romdat, rdata(dspa(d_ex) + 16) + a + 1, 1))
                b = b * &H400
                c = c * &H400
                For d = 0 To 127
                chrmap(d) = offs(gem, o_chroffs) + b + (d * &H10)
                chrmap(d + 128) = offs(gem, o_chroffs) + c + (d * &H10)
                Next d
                CA_ID = 0
            Else
                b = Asc(Mid(romdat, rdata(dspa(d_ex) + 13) + c, 1))
                If b >= &H80 Then
                    If ID_taken_tmp(a) = False Then
                        ID_taken_tmp(a) = True
                        PA_ID(a) = b
                        PA_DelayC(a) = 0
                        PA_FrameN(a) = 0
                    End If
                Else
                    For col = 1 To 3
                        glob_pal(a + col) = NESPAL(Asc(Mid(romdat, rdata(dspa(d_ex) + 15) + (b * 4) + col, 1)))
                        glob_pal(a + col + &H10) = NESPALD(Asc(Mid(romdat, rdata(dspa(d_ex) + 15) + (b * 4) + col, 1)))
                        glob_pal(a + col + &H30) = NESPALL(Asc(Mid(romdat, rdata(dspa(d_ex) + 15) + (b * 4) + col, 1)))
                        glob_pal(a + col + &H50) = NESPAL(Asc(Mid(romdat, rdata(dspa(d_ex) + 15) + (b * 4) + col, 1)))
                    Next col
                    c = Int(a / 4)
                    If ID_taken_tmp(c) = False Then
                        ID_taken_tmp(c) = True
                        PA_ID(c) = 0
                        PA_DelayC(c) = 0
                        PA_FrameN(c) = 0
                    End If
                    c = Asc(Mid(romdat, rdata(dspa(d_ex) + 15) + (b * 4), 1))
                    If c > 0 Then
                        If c > &H80 Then
                            glob_pal(0) = NESPAL(c And &H3F)
                            glob_pal(&H10) = NESPALD(c And &H3F)
                            glob_pal(&H30) = NESPALL(c And &H3F)
                            glob_pal(&H50) = NESPAL(c And &H3F)
                        Else
                            a = c: GoTo putchrbank5
                        End If
                    End If
                End If
            End If
        End If
    End If
End If
findeffsprnext5:
Next enem
donefindeffspr5:
End Select

If animcl = 1 Then Anim_Reset

Update_Global_Pal

If PalEd.Visible Then PalEd.Update_BGPal upd
If TileTable.Visible Then TileTable.Update_BGPal upd
If TSATable.Visible Then TSATable.Update_BGPal upd
If StrTable.Visible Then StrTable.Update_BGPal upd
If ScreenEd.Visible Then ScreenEd.Update_BGPal upd
If EnemEd.Visible Then EnemEd.Update_BGPal upd
End Sub

Public Sub Anim_Reset()
For a = 0 To 3
PA_DelayC(a) = 0
PA_FrameN(a) = 0
Next a
End Sub

Public Sub Update_Global_Pal()
CopyMem pal_bmi.pal(0), glob_pal(0), &H1FF
CopyMem pal2_bmi.pal(0), glob_pal(0), &H1FF
CopyMem tt_bmi.pal(0), glob_pal(0), &H1FF
CopyMem tsat_bmi.pal(0), glob_pal(0), &H1FF
CopyMem tsat_pal_bmi.pal(0), glob_pal(0), &H1FF
CopyMem sbds_scr_bmi.pal(0), glob_pal(0), &H1FF
CopyMem sbds_obj_bmi.pal(0), glob_pal(0), &H1FF
CopyMem str_bmi.pal(0), glob_pal(0), &H1FF
CopyMem scrn_scr_bmi.pal(0), glob_pal(0), &H1FF
CopyMem enem_scr_bmi.pal(0), glob_pal(0), &H1FF
CopyMem enem_scrb_bmi.pal(0), glob_pal(0), &H1FF
CopyMem enem_tile_bmi.pal(0), glob_pal(0), &H1FF
CopyMem enem_pal_bmi.pal(0), glob_pal(0), &H1FF
EnemEd.Update_Global_Pal
'For a = 0 To &HFF
'b = glob_pal(a)
'pal_bmi.pal(a) = b
'tt_bmi.pal(a) = b
'tsat_bmi.pal(a) = b
'tsat_pal_bmi.pal(a) = b
'sbds_scr_bmi.pal(a) = b
'sbds_obj_bmi.pal(a) = b
'str_bmi.pal(a) = b
'scrn_scr_bmi.pal(a) = b
'enem_scr_bmi.pal(a) = b
'enem_scrb_bmi.pal(a) = b
'enem_tile_bmi.pal(a) = b
'enem_pal_bmi.pal(a) = b
'Next a
End Sub

Public Sub Update_Global_SngCol(col)
b = glob_pal(col)
pal_bmi.pal(col) = b
pal2_bmi.pal(col) = b
tt_bmi.pal(col) = b
tsat_bmi.pal(col) = b
tsat_pal_bmi.pal(col) = b
sbds_scr_bmi.pal(col) = b
sbds_obj_bmi.pal(col) = b
str_bmi.pal(col) = b
scrn_scr_bmi.pal(col) = b
enem_scr_bmi.pal(col) = b
enem_scrb_bmi.pal(col) = b
enem_tile_bmi.pal(col) = b
enem_pal_bmi.pal(col) = b
If PalEd.Visible Then PalEd.Update_BGPal 1
If TileTable.Visible Then TileTable.Update_BGPal 1
If TSATable.Visible Then TSATable.Update_BGPal 1
If StrTable.Visible Then StrTable.Update_BGPal 1
If ScreenEd.Visible Then ScreenEd.Update_BGPal 1
If EnemEd.Visible Then EnemEd.Update_BGPal 1
End Sub

Public Sub Update_Scrn()
Dim spsmap, spscreen, col
spscreen = 0
curscroll_sscrn = 0
For spsmap = 0 To &H17
If nibble(Mid(romdat, (offs(gem, o_dirtype) + spsmap), 1), 0) = 0 Then GoTo spsmapskip
For a = 0 To nibble(Mid(romdat, (offs(gem, o_dirtype) + spsmap), 1), 1)
If spscreen = curscreen Then GoTo spsmapfound
spscreen = spscreen + 1
Next a
curscroll_sscrn = spscreen
spsmapskip:
Next spsmap
spsmapfound:
If curscroll <> spsmap And gem = 1 Then
    If spsmap = 0 Then
        InitEffectLoad
    Else
        ScrollEffectLoad spsmap
    End If
End If

curscroll = spsmap
nextscroll_sscrn = curscroll_sscrn + nibble(Mid(romdat, (offs(gem, o_dirtype) + spsmap), 1), 1) + 1

SprCHRPALSetup
Update_BGPal 1, 1
If ScreenEd.Visible = True Then ScreenEd.Update_Scrn
If EnemEd.Visible = True Then EnemEd.Update_Scrn
End Sub

Public Sub ScrollEffectLoad(scrollmap)
Dim offLo, offHi, EffectOff
offLo = Asc(Mid(romdat, rdata(dspa(d_ex) + 5) + Asc(Mid(romdat, offs(gem, o_ddB) + scrollmap, 1)), 1))
offHi = Asc(Mid(romdat, rdata(dspa(d_ex) + 6) + Asc(Mid(romdat, offs(gem, o_ddB) + scrollmap, 1)), 1))
EffectOff = (((offHi - &HA0) + rdata(dspa(d_ex) + 7)) * &H100) + offLo + &H11
EffectLoad EffectOff, 1
End Sub


Public Sub Update_StrBlock(str, block)
If ScreenEd.Visible = True Then ScreenEd.Update_StrBlock str, block
If EnemEd.Visible = True Then EnemEd.Update_StrBlock str, block
End Sub

Public Sub Update_ScrnStr(strY, strX)
If EnemEd.Visible = True Then EnemEd.Update_ScrnStr strY, strX
End Sub

Public Sub Update_Block(block)
If StrTable.Visible = True Then StrTable.Update_Block block
If ScreenEd.Visible = True Then ScreenEd.Update_Block block
If EnemEd.Visible = True Then EnemEd.Update_Block block
End Sub

Public Sub Update_TileRange(min As Byte, max As Byte)
If TileTable.Visible = True Then TileTable.Update_TileRange min, max
If TSATable.Visible = True Then TSATable.Update_TileRange min, max
If StrTable.Visible = True Then StrTable.Update_TileRange min, max
If ScreenEd.Visible = True Then ScreenEd.Update_TileRange min, max
If EnemEd.Visible = True Then EnemEd.Update_TileRange min, max
End Sub

Public Sub SprCHRPALSetup()
Dim sprchrbankoffs1 As Long, sprchrbankoffs2 As Long
Dim sprpalset, enemset, palset, col
'MsgBox Hex$(chrset)
Select Case gem
Case 0
    enemset = Asc(Mid(romdat, offs(gem, o_ddA) + (curscroll * 2) + 0, 1))
    sprchrbankoffs1 = Asc(Mid(romdat, rdata(dspa(10) + 0) + (enemset * 2), 1))
    sprchrbankoffs1 = sprchrbankoffs1 * &H400
    sprchrbankoffs2 = Asc(Mid(romdat, rdata(dspa(10) + 0) + (enemset * 2) + 1, 1))
    sprchrbankoffs2 = sprchrbankoffs2 * &H400

    Dim t
    For t = 0 To 63
    chrmap(t + &H180) = rdata(dspa(gem) + 2) + sprchrbankoffs1 + (t * &H10)
    chrmap(t + &H1C0) = rdata(dspa(gem) + 2) + sprchrbankoffs2 + (t * &H10)
    Next t

    For col = 0 To 7
    If (col And 3) Then
'    global_pal(col + &H48) = RGB(&H80, 0, &H80)
'Else
    'MsgBox Hex(NESPAL(Asc(Mid(romdat, offs(gem, 27) + (enemset * 8) + col, 1))))
        sprpaloff(col) = offs(gem, 27) + (enemset * 8) + col
        glob_pal(col + &H48) = NESPAL(Asc(Mid(romdat, offs(gem, 27) + (enemset * 8) + col, 1)))
    End If
    Next col
Case 2
    'enemset = Asc(Mid(romdat, offs(gem, o_ddA) + (curscroll * 2) + 0, 1))
    'sprchrbankoffs1 = Asc(Mid(romdat, rdata(dspa(10) + 0) + (enemset * 2), 1))
    'sprchrbankoffs1 = sprchrbankoffs1 * &H400
    'sprchrbankoffs2 = Asc(Mid(romdat, rdata(dspa(10) + 0) + (enemset * 2) + 1, 1))
    'sprchrbankoffs2 = sprchrbankoffs2 * &H400

    'Dim t
    'For t = 0 To 63
    'chrmap(t + &H180) = rdata(dspa(gem) + 2) + sprchrbankoffs1 + (t * &H10)
    'chrmap(t + &H1C0) = rdata(dspa(gem) + 2) + sprchrbankoffs2 + (t * &H10)
    'Next t

    sprpalset = Asc(Mid(romdat, offs(gem, o_ddA) + curscroll, 1)) And &H3F

    For col = 0 To 7
        If sprpalset > 0 Then
            sprpaloff(col) = offs(gem, 27) + ((sprpalset - 1) * 8) + col
            If (col And 3) > 0 Then glob_pal(col + &H48) = NESPAL(Asc(Mid(romdat, sprpaloff(col), 1)))
        Else
            sprpaloff(col) = offs(gem, 49) + 8 + col
            If (col And 3) > 0 Then glob_pal(col + &H48) = NESPAL(Asc(Mid(romdat, sprpaloff(col), 1)))
        End If
    Next col
End Select

Update_Global_Pal
End Sub

Private Sub Form_Unload(Cancel As Integer)
Unload Config
Unload DumpRes
Unload PalEd
Unload EnemEd
Unload PalChart
Unload SBDSpecial
Unload StrTable
Unload ScreenEd
Unload TileTable
Unload TSATable
Set Config = Nothing
Set DumpRes = Nothing
Set PalEd = Nothing
Set EnemEd = Nothing
Set PalChart = Nothing
Set SBDSpecial = Nothing
Set StrTable = Nothing
Set ScreenEd = Nothing
Set TileTable = Nothing
Set TSATable = Nothing
End Sub

Private Sub Level_Misc_Click()
MiscEd.Update
MiscEd.Show
End Sub

Public Sub Level_Next_Click()
If Not level = offs(gem, 0) Then level = level + 1: MFLE_Main.Update_Level
End Sub

Public Sub Level_Previous_Click()
If Not level = 0 Then level = level - 1: MFLE_Main.Update_Level
End Sub

Private Sub Command1_Click()
DumpRes.Show
End Sub

Private Sub File_Exit_Click()
Form_Unload 0
Unload Me
Set MFLE_Main = Nothing
End Sub

Public Sub File_Save_Click()
FileCopy FileName, "backup.rom"
Open FileName For Binary As #1
Put #1, , romdat
Close #1
End Sub

Public Sub File_Back_Click()
If Dir("backup.rom") = "" Then MsgBox "No backup!": Exit Sub
Open "backup.rom" For Binary As #1
Get #1, , romdat
Close #1
Update_Level
End Sub

Private Sub Menu_Config_Click()
Config.Update
Config.Show
End Sub

Public Sub Tools_Test_Click()
If GetCfg("emufname") = "" Then MsgBox "Set Emulator location in Config first!": Exit Sub
Shell GetCfg("emufname") + " " + sse + FileName + sse, vbNormalFocus
End Sub

Public Sub View_EnemEd_Click()
EnemEd.Update
EnemEd.Show 'find out why switching these two does funky stuff
End Sub

Public Sub View_PalEd_Click()
PalEd.Update
PalEd.Show
End Sub

Public Sub View_SBDS_Click()
SBDSpecial.Update
SBDSpecial.Show
End Sub

Public Sub View_ScreenEd_Click()
ScreenEd.Update
ScreenEd.Show
End Sub

Public Sub View_StrT_Click()
StrTable.Update
StrTable.Show
End Sub

Public Sub View_TSAT_Click()
TSATable.Update
TSATable.Show
End Sub

Public Sub View_TT_Click()
TileTable.Update
TileTable.Show
End Sub

Private Sub CHRAnimT_Timer()
Dim id, idoff
If gem < 2 Then Exit Sub
If CA_ID >= &H80 Then
    id = CA_ID And &H7F
    idoff = Asc(Mid(romdat, rdata(dspa(d_ex) + 17) + id, 1))
    a = CA_DelayC
    CA_DelayC = (CA_DelayC + 1) And &HFF
    If CA_DelayC >= Asc(Mid(romdat, rdata(dspa(d_ex) + 18) + idoff + 1, 1)) Then
        CA_DelayC = 0
        a = CA_FrameN
        CA_FrameN = (CA_FrameN + 1) And &HFF
        If a >= Asc(Mid(romdat, rdata(dspa(d_ex) + 18) + idoff, 1)) Then CA_FrameN = 0
        b = Asc(Mid(romdat, rdata(dspa(d_ex) + 18) + idoff + 2, 1))
        c = Asc(Mid(romdat, rdata(dspa(d_ex) + 18) + idoff + 3 + CA_FrameN, 1))
        c = c * &H400
        For d = 0 To 127
            chrmap(d + (b * &H80)) = offs(gem, o_chroffs) + c + (d * &H10)
        Next d
        MFLE_Main.Update_TileRange (b * &H80), (b * &H80) + &H7F
    End If
End If
'Gravityman Special
If level = 0 Then
    a = Int(Gman_FC / 8) And 3
    If a <> Gman_OF Then
        Gman_OF = a
        b = Asc(Mid(romdat, &H3DF60 + a, 1))
        b = b * &H400
        For c = 0 To 127
            chrmap(c) = offs(gem, o_chroffs) + b + (c * &H10)
        Next c
        MFLE_Main.Update_TileRange 0, &H7F
    End If
    Gman_FC = ((Gman_FC + 1) And &HFF)
End If
End Sub

Private Sub PalAnimT_Timer()
'Static tick
'PalAnim
'tick = tick + 66: If tick > 99 Then tick = tick - 100
'End Sub
'
'Private Sub PalAnim()
Dim slot, id, idoLo, idoHi, idoff, framepalptr, col
Select Case gem
Case 0
For slot = 0 To 3
If PA_ID(slot) >= &H80 Then
    id = PA_ID(slot) And &H7F
    idoff = Asc(Mid(romdat, &H12611 + id, 1))
    If PA_DelayC(slot) >= Asc(Mid(romdat, &H12620 + idoff, 1)) Then
        PA_DelayC(slot) = 0
        a = PA_FrameN(slot)
        PA_FrameN(slot) = (PA_FrameN(slot) + 1) And &HFF
        If a >= Asc(Mid(romdat, &H1261F + idoff, 1)) Then PA_FrameN(slot) = 0
        framepalptr = (Asc(Mid(romdat, &H12622 + idoff + PA_FrameN(slot), 1)) * 3) And &HFF
        'If framepalptr = 0 Then PA_ID(slot) = 0: Exit Sub
        For col = 0 To 2
            glob_pal((Asc(Mid(romdat, &H12621 + idoff, 1)) + col) And 15) = NESPAL(Asc(Mid(romdat, &H1259F + framepalptr + col, 1)))
            glob_pal(((Asc(Mid(romdat, &H12621 + idoff, 1)) + col) And 15) + &H10) = NESPALD(Asc(Mid(romdat, &H1259F + framepalptr + col, 1)))
            glob_pal(((Asc(Mid(romdat, &H12621 + idoff, 1)) + col) And 15) + &H30) = NESPALL(Asc(Mid(romdat, &H1259F + framepalptr + col, 1)))
            'tsat_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tsat_pal_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tt_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'sbds_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'enem_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + &H10 + col) = NESPALD(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
        Next col
        Update_Global_Pal
        MFX_Render.RenderPic PalEd.PalPic2, pal2_bmi
        MFX_Render.RenderPic TSATable.tsapic, tsat_bmi
        MFX_Render.RenderPic TSATable.PalPic, tsat_pal_bmi
        MFX_Render.RenderPic TileTable.pic1, tt_bmi
        MFX_Render.RenderPic SBDSpecial.ScreenPic, sbds_scr_bmi
        MFX_Render.RenderPic StrTable.StrPic, str_bmi
        MFX_Render.RenderPic ScreenEd.ScreenPic, scrn_scr_bmi
        MFX_Render.RenderPic EnemEd.ScreenPic, enem_scr_bmi
    Else
        PA_DelayC(slot) = PA_DelayC(slot) + 1
    End If
End If
Next slot

Case 1
For slot = 0 To 3
If PA_ID(slot) >= &H80 Then
    id = PA_ID(slot) And &H7F
    idoLo = Asc(Mid(romdat, offs(gem, 53) + id, 1))
    idoHi = Asc(Mid(romdat, offs(gem, 54) + id, 1))
    idoff = (((idoHi - &HA0) + offs(gem, 55)) * &H100) + idoLo + &H11
    'MsgBox Hex(idoff): End
    If PA_DelayC(slot) >= Asc(Mid(romdat, idoff + 1, 1)) Then
        PA_DelayC(slot) = 0
        a = PA_FrameN(slot)
        PA_FrameN(slot) = (PA_FrameN(slot) + 1) And &HFF
        If a >= Asc(Mid(romdat, idoff, 1)) Then PA_FrameN(slot) = 0
        framepalptr = (Asc(Mid(romdat, idoff + 2 + PA_FrameN(slot), 1)) * 3)
        If framepalptr = 0 Then PA_ID(slot) = 0: Exit Sub
        For col = 0 To 2
            glob_pal(((slot * 4) + 1 + col) And 15) = NESPAL(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            glob_pal((((slot * 4) + 1 + col) And 15) + &H10) = NESPALD(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            glob_pal((((slot * 4) + 1 + col) And 15) + &H30) = NESPALL(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            If id = 7 Then glob_pal(&H49 + col) = NESPAL(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            'tsat_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tsat_pal_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tt_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'sbds_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'enem_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + &H10 + col) = NESPALD(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
        Next col
        Update_Global_Pal
        MFX_Render.RenderPic PalEd.PalPic2, pal2_bmi
        MFX_Render.RenderPic TSATable.tsapic, tsat_bmi
        MFX_Render.RenderPic TSATable.PalPic, tsat_pal_bmi
        MFX_Render.RenderPic TileTable.pic1, tt_bmi
        MFX_Render.RenderPic SBDSpecial.ScreenPic, sbds_scr_bmi
        MFX_Render.RenderPic StrTable.StrPic, str_bmi
        MFX_Render.RenderPic ScreenEd.ScreenPic, scrn_scr_bmi
        MFX_Render.RenderPic EnemEd.ScreenPic, enem_scr_bmi
    Else
        PA_DelayC(slot) = PA_DelayC(slot) + 1
    End If
End If
Next slot

Case 2
For slot = 0 To 3
If PA_ID(slot) >= &H80 Then
    id = PA_ID(slot) And &H7F
    idoff = Asc(Mid(romdat, offs(gem, 53) + id, 1))
    If PA_DelayC(slot) >= Asc(Mid(romdat, offs(gem, 54) + idoff + 1, 1)) Then
        PA_DelayC(slot) = 0
        a = PA_FrameN(slot)
        PA_FrameN(slot) = (PA_FrameN(slot) + 1) And &HFF
        If a >= Asc(Mid(romdat, offs(gem, 54) + idoff, 1)) Then PA_FrameN(slot) = 0
        framepalptr = (Asc(Mid(romdat, offs(gem, 54) + idoff + 2 + PA_FrameN(slot), 1)) * 3) And &HFF
        If framepalptr = 0 Then PA_ID(slot) = 0: Exit Sub
        For col = 0 To 2
            glob_pal(((slot * 4) + 1 + col) And 15) = NESPAL(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            glob_pal((((slot * 4) + 1 + col) And 15) + &H10) = NESPALD(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            glob_pal((((slot * 4) + 1 + col) And 15) + &H30) = NESPALL(Asc(Mid(romdat, offs(gem, 56) + framepalptr + col, 1)))
            'tsat_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tsat_pal_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'tt_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'sbds_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + col) = NESPAL(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
            'enem_scr_bmi.pal(Asc(mid(romdat, &H12621 + idoff, 1)) + &H10 + col) = NESPALD(Asc(mid(romdat, &H1259F + framepalptr + col, 1)))
        Next col
        Update_Global_Pal
        MFX_Render.RenderPic PalEd.PalPic2, pal2_bmi
        MFX_Render.RenderPic TSATable.tsapic, tsat_bmi
        MFX_Render.RenderPic TSATable.PalPic, tsat_pal_bmi
        MFX_Render.RenderPic TileTable.pic1, tt_bmi
        MFX_Render.RenderPic SBDSpecial.ScreenPic, sbds_scr_bmi
        MFX_Render.RenderPic StrTable.StrPic, str_bmi
        MFX_Render.RenderPic ScreenEd.ScreenPic, scrn_scr_bmi
        MFX_Render.RenderPic EnemEd.ScreenPic, enem_scr_bmi
    Else
        PA_DelayC(slot) = PA_DelayC(slot) + 1
    End If
End If
Next slot

End Select

End Sub
