Attribute VB_Name = "MFX_Render"
Option Explicit

'This is the orginal SetDIBits, i dont use it but you can incluse it if you want
'Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, ByVal lpBI As Long, ByVal wUsage As Long) As Long

Public Declare Sub CopyMem Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal SizeLength&)
Public Declare Sub ZeroMem Lib "kernel32" Alias "RtlZeroMemory" (pDest As Any, ByVal Bytes As Long)
Public Declare Sub FillMem Lib "kernel32" Alias "RtlFillMemory" (pDest As Any, ByVal SizeLength&, ByVal Value As Byte)

Public Type BITMAPINFOHEADER
  biSize As Long
  biWidth As Long
  biHeight As Long
  biPlanes As Integer
  biBitCount As Integer
  biCompression As Long
  biSizeImage As Long
  biXPelsPerMeter As Long
  biYPelsPerMeter As Long
  biClrUsed As Long
  biClrImportant As Long
End Type
Public Type BITMAPINFO
  Header As BITMAPINFOHEADER
  pal(255) As Long
  bits() As Byte
End Type

'Public Function DrawTile(BitMapBuffer() As Long, Tileoffs As Long, Colors(), ByVal x As Long, ByVal y As Long, ByVal Mulitply As Byte) As Long
'  If bInit = False Then Exit Function
'  DrawTile = DrawTile2(BitMapBuffer(), Tileoffs, Colors(), x, y, Picbox.width, Picbox.height, Mulitply)
'End Function

Public Sub DrawTile(TilePB, bmix As BITMAPINFO, ByVal Tileoffs As Double, tilepal, ByVal X As Long, ByVal Y As Long, ByVal Mulitply As Long)
Dim width, height
If Tileoffs < 0 Or Tileoffs > (Len(romdat) - &H10) Then Exit Sub
width = TilePB.width
height = TilePB.height
'  If bInit = False Then Exit Function
  Dim tileX As Long, tileY As Long
  Dim TileColour As Long, X1 As Long, X2 As Long
  Dim i As Long, mx As Long, my As Long
'Dim bleh As Long
  For tileY = 0 To 7
  X1 = Asc(Mid(romdat, Tileoffs + tileY + 1, 1))
  X2 = Asc(Mid(romdat, Tileoffs + tileY + 9, 1))
  For tileX = 0 To 7
    TileColour = _
      ((X1 And (2 ^ (7 - tileX))) > 0 And 1) + _
      ((X2 And (2 ^ (7 - tileX))) > 0 And 1 * 2)
    
    For my = 0 To Mulitply - 1
    For mx = 0 To Mulitply - 1
'      i = ((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx
'      If i > width * height * 4 Then Exit Function
    bmix.bits(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) = (tilepal * 4) + TileColour
    Next mx
    Next my
  Next tileX
  Next tileY
End Sub

Public Sub DrawSprTile(TilePB, bmix As BITMAPINFO, ByVal Tileoffs As Double, tilepal, ByVal X As Long, ByVal Y As Long, ByVal Mulitply As Long, FlipY, FlipX)
Dim width, height
width = TilePB.width
height = TilePB.height
'  If bInit = False Then Exit Function
  Dim tileX As Long, tileY As Long
  Dim TileColour As Long, X1 As Long, X2 As Long
  Dim i As Long, mx As Long, my As Long

  For tileY = 0 To 7
  X1 = Asc(Mid(romdat, Tileoffs + Abs((FlipY * 7) - tileY) + 1, 1))
  X2 = Asc(Mid(romdat, Tileoffs + Abs((FlipY * 7) - tileY) + 9, 1))
'byteA = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 1, 1))
'byteB = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 2, 1))

  For tileX = 0 To 7
    TileColour = _
      ((X1 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1) + _
      ((X2 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1 * 2)
 '     ((X1 And (2 ^ (7 - tileX))) > 0 And 1) + _
 '     ((X2 And (2 ^ (7 - tileX))) > 0 And 1 * 2)
    If TileColour Then
    For my = 0 To Mulitply - 1
    For mx = 0 To Mulitply - 1
'      i = ((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx
     
 '   If i > width * height * 4 Then Exit Sub
    If (((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) > -1 Then
'    If (((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx) < width * height Then
    bmix.bits(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) = (tilepal * 4) + TileColour
    End If
    Next mx
    Next my
    End If
  Next tileX
  Next tileY
End Sub

Public Sub ClearSprTile(TilePB, bmix As BITMAPINFO, SrcBMB() As Byte, ByVal Tileoffs As Double, tilepal, ByVal X As Long, ByVal Y As Long, ByVal Mulitply As Long, FlipY, FlipX)
Dim width, height
width = TilePB.width
height = TilePB.height
'  If bInit = False Then Exit Function
  Dim tileX As Long, tileY As Long
  Dim TileColour As Long, X1 As Long, X2 As Long
  Dim i As Long, mx As Long, my As Long

  For tileY = 0 To 7
  X1 = Asc(Mid(romdat, Tileoffs + Abs((FlipY * 7) - tileY) + 1, 1))
  X2 = Asc(Mid(romdat, Tileoffs + Abs((FlipY * 7) - tileY) + 9, 1))
'byteA = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 1, 1))
'byteB = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 2, 1))

  For tileX = 0 To 7
    TileColour = _
      ((X1 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1) + _
      ((X2 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1 * 2)
 '     ((X1 And (2 ^ (7 - tileX))) > 0 And 1) + _
 '     ((X2 And (2 ^ (7 - tileX))) > 0 And 1 * 2)
    If TileColour Then
    For my = 0 To Mulitply - 1
    For mx = 0 To Mulitply - 1
'      i = ((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx
     
 '   If i > width * height * 4 Then Exit Sub
    If (((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) > -1 Then
'    If (((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx) < width * height Then
    bmix.bits(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) = SrcBMB(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx)
    End If
    Next mx
    Next my
    End If
  Next tileX
  Next tileY
End Sub
Public Sub DrawSprTile_Br(TilePB, bmix As BITMAPINFO, src_bmix As BITMAPINFO, Tileoffs As Long, Colors(), ByVal X As Long, ByVal Y As Long, ByVal Mulitply As Long, FlipY, FlipX, BrY1, BrX1, BrY2, BrX2)
Dim width, height
width = TilePB.width
height = TilePB.height
'  If bInit = False Then Exit Function
  Dim tileX As Long, tileY As Long
  Dim TileColour As Long, X1 As Long, X2 As Long
  Dim i As Long, mx As Long, my As Long

  For tileY = 0 To 7
  X1 = Asc(Mid(chrdat$, Tileoffs + (Abs((FlipY * 7) - tileY) * 2) + 1, 1))
  X2 = Asc(Mid(chrdat$, Tileoffs + (Abs((FlipY * 7) - tileY) * 2) + 2, 1))
'byteA = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 1, 1))
'byteB = Asc(mid(romdat, Source + (Abs((FlipY * 7) - pixY) * 2) + 2, 1))

  For tileX = 0 To 7
    TileColour = _
      ((X1 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1) + _
      ((X2 And (2 ^ (7 - Abs((FlipX * 7) - tileX)))) > 0 And 1 * 2)
 '     ((X1 And (2 ^ (7 - tileX))) > 0 And 1) + _
 '     ((X2 And (2 ^ (7 - tileX))) > 0 And 1 * 2)
    If TileColour Then
    For my = 0 To Mulitply - 1
    For mx = 0 To Mulitply - 1
'      i = ((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx
'      If i > width * height * 4 Then Exit Function
    If (X + (tileX * Mulitply) + mx) >= BrX1 And (X + (tileX * Mulitply) + mx) <= BrX2 And (Y + (tileY * Mulitply) + my) >= BrY1 And (Y + (tileY * Mulitply) + my) <= BrY2 Then
    If (((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) > -1 Then
'    If (((y * width) + (tileY * width) * Mulitply + my * width) + x + tileX * Mulitply + mx) < width * height Then
        bmix.bits(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx) = src_bmix.bits(((Y * width) + (tileY * width) * Mulitply + my * width) + X + tileX * Mulitply + mx)
'    End If
    End If
    End If
    Next mx
    Next my
    End If
  Next tileX
  Next tileY
End Sub

Public Sub LineH(Picbox As PictureBox, bmix As BITMAPINFO, X1, X2, Y, col)
Dim width, height, a
width = Picbox.width
height = Picbox.height
    For a = X1 To X2
    If ((Y * width) + a) < (width * height) And ((Y * width) + a) > -1 Then bmix.bits((Y * width) + a) = col
    Next a
End Sub

Public Sub LineV(Picbox As PictureBox, bmix As BITMAPINFO, X, y1, y2, col)
Dim width, height, a
width = Picbox.width
height = Picbox.height
    For a = y1 To y2
    If ((a * width) + X) < (width * height) And ((a * width) + X) > -1 Then bmix.bits((a * width) + X) = col
    Next a
End Sub

Public Sub FBox(Picbox As PictureBox, bmix As BITMAPINFO, X1, y1, X2, y2, col)
Dim X, Y
For Y = y1 To y2: For X = X1 To X2
    If ((Y * Picbox.width) + X) < (Picbox.width * Picbox.height) And ((Y * Picbox.width) + X) > -1 Then bmix.bits((Y * Picbox.width) + X) = col
Next X: Next Y
End Sub

Public Function RenderPic(TilePB As PictureBox, bmix As BITMAPINFO) As Long
Dim pbmi As Long
pbmi = VarPtr(bmix)
'  If bInit = False Then Exit Function
  RenderPic = SetDIBits(TilePB.hdc, TilePB.Image.Handle, 0, TilePB.ScaleHeight, bmix.bits(0), pbmi, 0)
TilePB.Refresh
End Function

Public Sub PB_Init(TilePB As PictureBox, bmix As BITMAPINFO)
'  On Error GoTo errhandle
'  Set PictureBox = Tilebox
Dim pBih As Long
    pBih = VarPtr(bmix.Header)
  Dim WidthOf As Long, HeightOf As Long
  WidthOf = TilePB.ScaleWidth + (TilePB.width - TilePB.ScaleWidth)
  HeightOf = TilePB.ScaleHeight
'  Dim bmiID As BITMAPINFO
  With bmix.Header
    .biSize = 40
    .biWidth = WidthOf
    .biHeight = -HeightOf
    .biPlanes = 1
    .biBitCount = 8
    .biSizeImage = 2 * (WidthOf - 1) * (HeightOf - 1)
    .biClrUsed = 256
  End With
  CopyMem ByVal pBih, bmix.Header, Len(bmix.Header)
  ReDim bmix.bits(bmix.Header.biSizeImage - 1)
'Dim pp As Long
'pp = VarPtr(bmix.pal(0))
'CopyMem ByVal VarPtr(bmix.pal(0)), glob_pal(0), &HFF
End Sub

Public Sub Reset_Bits(TilePB As PictureBox, bmix As BITMAPINFO)
ReDim bmix.bits(0)
ReDim bmix.bits(bmix.Header.biSizeImage - 1)
End Sub
