VERSION 5.00
Begin VB.Form StrTable 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Structure Table"
   ClientHeight    =   7740
   ClientLeft      =   45
   ClientTop       =   420
   ClientWidth     =   7755
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7740
   ScaleWidth      =   7755
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox StrPic 
      AutoRedraw      =   -1  'True
      HasDC           =   0   'False
      Height          =   7760
      Left            =   0
      ScaleHeight     =   513
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   513
      TabIndex        =   0
      Top             =   0
      Width           =   7760
   End
End
Attribute VB_Name = "StrTable"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
MFX_Render.PB_Init StrPic, str_bmi
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
MFLE_Main.Global_KeyDown KeyCode, Shift
'If KeyCode = vbKeyF7 Then MFLE_Main.Level_Next_Click
'If KeyCode = vbKeyF6 Then MFLE_Main.Level_Previous_Click
End Sub

Public Sub Update()
Update_Level
Update_BGPal 1
End Sub

Public Sub Update_Level()
Dim strY, strX, blockY, blockX, blocknum, tilepal
Dim tileY, tileX, Y, X
'screen = Asc(mid(romdat, (offs(gem, 7) + curscreen), 1))
For strY = 0 To 15
For strX = 0 To 15
'strnum = Asc(mid(romdat, (offs(gem, 6) + (screen * 64) + ((strY * 8) + strX)), 1))
'strnum =
For blockY = 0 To 1
For blockX = 0 To 1
blocknum = Asc(Mid(romdat, (offs(gem, 5) + (((strY * 16) + strX) * 4) + ((blockY * 2) + blockX)), 1))
tilepal = nibble(Mid(romdat, (offs(gem, 4) + blocknum), 1), 1)
Y = ((strY * 32) + blockY * 16)
X = ((strX * 32) + blockX * 16)
For tileY = 0 To 1
For tileX = 0 To 1
'tilenum =
MFX_Render.DrawTile StrPic, str_bmi, chrmap(Asc(Mid(romdat, (offs(gem, 3) + (((tileY * 2) + tileX) * &H100) + blocknum), 1))), tilepal, X + (tileX * 8), Y + (tileY * 8), 1
Next tileX
Next tileY
Next blockX
Next blockY
Next strX
Next strY
DrawGrid
MFX_Render.RenderPic StrPic, str_bmi
End Sub

Public Sub Update_Block(ublock)
Dim strY, strX, blockY, blockX, blocknum, tilepal
Dim tileY, tileX, Y, X
'screen = Asc(mid(romdat, (offs(gem, 7) + curscreen), 1))
For strY = 0 To 15
For strX = 0 To 15
'strnum = Asc(mid(romdat, (offs(gem, 6) + (screen * 64) + ((strY * 8) + strX)), 1))
'strnum =
For blockY = 0 To 1
For blockX = 0 To 1
blocknum = Asc(Mid(romdat, (offs(gem, 5) + (((strY * 16) + strX) * 4) + ((blockY * 2) + blockX)), 1))
If Not blocknum = ublock Then GoTo skipblock
tilepal = nibble(Mid(romdat, (offs(gem, 4) + blocknum), 1), 1)
Y = ((strY * 32) + blockY * 16)
X = ((strX * 32) + blockX * 16)
For tileY = 0 To 1
For tileX = 0 To 1
'tilenum =
MFX_Render.DrawTile StrPic, str_bmi, chrmap(Asc(Mid(romdat, (offs(gem, 3) + (((tileY * 2) + tileX) * &H100) + blocknum), 1))), tilepal, X + (tileX * 8), Y + (tileY * 8), 1
Next tileX
Next tileY
skipblock:
Next blockX
Next blockY
Next strX
Next strY
DrawGrid
MFX_Render.RenderPic StrPic, str_bmi
End Sub

Public Sub Update_TileRange(min As Byte, max As Byte)
Dim strY, strX, blockY, blockX, blocknum, tilepal, tilenum
Dim tileY, tileX, Y, X
For strY = 0 To 15
For strX = 0 To 15
For blockY = 0 To 1
For blockX = 0 To 1
blocknum = Asc(Mid(romdat, (offs(gem, 5) + (((strY * 16) + strX) * 4) + ((blockY * 2) + blockX)), 1))
tilepal = nibble(Mid(romdat, (offs(gem, 4) + blocknum), 1), 1)
Y = ((strY * 32) + blockY * 16)
X = ((strX * 32) + blockX * 16)
For tileY = 0 To 1
For tileX = 0 To 1
tilenum = Asc(Mid(romdat, (offs(gem, 3) + (((tileY * 2) + tileX) * &H100) + blocknum), 1))
If tilenum >= min And tilenum <= max Then MFX_Render.DrawTile StrPic, str_bmi, chrmap(Asc(Mid(romdat, (offs(gem, 3) + (((tileY * 2) + tileX) * &H100) + blocknum), 1))), tilepal, X + (tileX * 8), Y + (tileY * 8), 1
Next tileX
Next tileY
Next blockX
Next blockY
Next strX
Next strY
DrawGrid
MFX_Render.RenderPic StrPic, str_bmi
End Sub

Public Sub Update_BGPal(upd)
If upd Then MFX_Render.RenderPic StrPic, str_bmi
End Sub

Private Sub DrawGrid()
For a = 0 To 15
For b = 0 To 15
MFX_Render.LineH StrPic, str_bmi, (b * 32), (b * 32) + 31, (a * 32), &H20
MFX_Render.LineV StrPic, str_bmi, (b * 32), (a * 32), (a * 32) + 31, &H20
Next b
Next a

CurStrSet 0
End Sub

Public Sub CurStrSet(upd)
MFX_Render.LineH StrPic, str_bmi, (oldstrX * 32), (oldstrX * 32) + 31, (oldstrY * 32), &H20
MFX_Render.LineV StrPic, str_bmi, (oldstrX * 32), (oldstrY * 32), (oldstrY * 32) + 32, &H20
MFX_Render.LineH StrPic, str_bmi, (oldstrX * 32), (oldstrX * 32) + 31, (oldstrY * 32) + 32, &H20
MFX_Render.LineV StrPic, str_bmi, (oldstrX * 32) + 32, (oldstrY * 32), (oldstrY * 32) + 32, &H20

MFX_Render.LineH StrPic, str_bmi, (curstrX * 32), (curstrX * 32) + 31, (curstrY * 32), &H22
MFX_Render.LineV StrPic, str_bmi, (curstrX * 32), (curstrY * 32), (curstrY * 32) + 32, &H22
MFX_Render.LineH StrPic, str_bmi, (curstrX * 32), (curstrX * 32) + 31, (curstrY * 32) + 32, &H22
MFX_Render.LineV StrPic, str_bmi, (curstrX * 32) + 32, (curstrY * 32), (curstrY * 32) + 32, &H22
If upd Then MFX_Render.RenderPic StrPic, str_bmi
End Sub

Private Sub StrPic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim blocknum, tileY, tileX
If Button = 1 Then
    oldstrY = curstrY
    oldstrX = curstrX
    curstrY = VWidth(Int(Y / 32), 0, &HF)
    curstrX = VWidth(Int(X / 32), 0, &HF)
    CurStrSet 1
End If
If Button = 2 Then
    a = Int(Y / 32)
    b = Int(X / 32)
    c = (Int(Y / 16) And 1)
    d = (Int(X / 16) And 1)
    Mid(romdat, (offs(gem, 5) + (((a * 16) + b) * 4) + ((c * 2) + d)), 1) = Chr((curblockY * 16) + curblockX)
    blocknum = Asc(Mid(romdat, (offs(gem, 5) + (((a * 16) + b) * 4) + ((c * 2) + d)), 1))
    For tileY = 0 To 1
    For tileX = 0 To 1
    MFX_Render.DrawTile StrPic, str_bmi, chrmap(Asc(Mid(romdat, (offs(gem, 3) + (((tileY * 2) + tileX) * &H100) + blocknum), 1))), nibble(Mid(romdat, (offs(gem, 4) + blocknum), 1), 1), (b * 32) + (d * 16) + (tileX * 8), (a * 32) + (c * 16) + (tileY * 8), 1
    Next tileX
    Next tileY
    CurStrSet 1
    MFLE_Main.Update_StrBlock (a * 16) + b, (c * 2) + d
End If
End Sub

Private Sub StrPic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = 1 Then StrPic_MouseDown Button, Shift, X, Y
End Sub
